#pragma once
#define MY_DRVICE_NAME L"YhyDrvice"
#define KERNEL_REG_DRVICE_NAME L"\\Device\\" MY_DRVICE_NAME
#define SYMBOLIC_LINK L"\\??\\" MY_DRVICE_NAME
// 内核注册的同步事件对象
#define NOTIFICATION_OBJECT_NAME L"\\BaseNamedObjects\\YhyDrvice"
#define KERNEL_TO_USER_EVENT_NAME L"Global\\YhyDrvice"
#define KERNEL_FILE_NAME L"\\\\.\\" MY_DRVICE_NAME

#define DEFINE_IOCTL(function_code) \
    CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800 + function_code, METHOD_BUFFERED, FILE_ANY_ACCESS)

// 读取任意内存地址数据
#define IOCTL_READ_MEMORY DEFINE_IOCTL(1)

typedef struct ReadMemoryModel {
    void* address;
    int   len;
} ReadMemoryModel;

// 写入内存地址数据
#define IOCTL_WRITE_MEMORY    DEFINE_IOCTL(2)
typedef struct WriteMemoryModel {
    void* address; // 目标地址
    int   len;     // 写入数据量
    char buffer[1]; // 缓冲区
} WriteMemoryModel;

// 枚举进程
#define IOCTL_ENUMERATION_PROCESS    DEFINE_IOCTL(3)

typedef struct EnumerationProcessModel {
    // TODO: ...
} EnumerationProcessModel;

// 内核驱动创建命名的事件同步对象，用来让应用层接收事件
#define IOCTL_KERNEL_CREATE_EVENT_OBJECT    CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800 + 4, METHOD_NEITHER , FILE_ANY_ACCESS)

// 通知内核驱动关闭命名的事件对象
#define IOCTL_CLOSE_EVENT_OBJECT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800 + 5, METHOD_NEITHER , FILE_ANY_ACCESS)